<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use think\Db;
/**
 * 实名认证申请
 *
 * @icon fa fa-circle-o
 */
class Useridconfirm extends Backend
{
    
    /**
     * Useridconfirm模型对象
     * @var \app\admin\model\Useridconfirm
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\Useridconfirm;
        $this->view->assign("statusList", $this->model->getStatusList());
    }

    public function import()
    {
        parent::import();
    }

    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */
    

    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['user'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('user')->visible(['username']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

    /**
     * 审核
     */
    public function audit(){
        $id = input('id');
        $info = Db::name('user_idconfirm')
            ->where('id',$id)
            ->find();

        if ($this->request->isPost()) {
            $status = input('status');
            $data = [
                'status' => $status,
                'auditremark' => input('auditremark'),
                'audittime' => time(),
                'updatetime' => time(),
            ];
            Db::startTrans();
            $userinfo = Db::name('user')->where('id',$info['user_id'])->lock(true)->find();
            $rs = Db::name('user_idconfirm')->where('id',$id)->update($data);

            //修改用户表
            $update = [
                'idcard_status'=>$data['status'],
            ];
            $rs = Db::name('user')->where('id',$info['user_id'])->update($update);

            //本来应该在审核通过的时候把信息同步到user表，现在不这么做了

            //tag任务赠送金币
            if($status == 1){
                //完成实名认证  +20金币
                $task_rs = \app\common\model\TaskLog::tofinish($info['user_id'],4);
                if($task_rs === false){
                    Db::rollback();
                    $this->error('完成任务赠送奖励失败');
                }
                //完成本人基本资料 +15金币《所有资料完善，包括真人认证和实名认证》
                $task_rs = \app\common\model\TaskLog::tofinish($info['user_id'],5);
                if($task_rs === false){
                    Db::rollback();
                    $this->error('完成任务赠送奖励失败');
                }

                //邀请人拿奖励，男性3元
                $intro_money = $userinfo['gender'] == 1 ? config('site.intro_man_money') : config('site.intro_woman_money');
                if($userinfo['real_status'] == 1 && !empty($userinfo['intro_uid']) && $intro_money > 0){
                    $task_rs = model('wallet')->lockChangeAccountRemain($userinfo['intro_uid'],'money',$intro_money,63,$remark='');
                    if($task_rs['status'] === false){
                        Db::rollback();
                        $this->error($task_rs['msg']);
                    }
                }

                //系统消息
                $msg_id = \app\common\model\Message::addMessage($info['user_id'],'实名认证','实名认证已经审核通过');
            }elseif($status == 2){
                //系统消息
                $msg_id = \app\common\model\Message::addMessage($info['user_id'],'实名认证','实名认证审核不通过');
            }
            Db::commit();

            $this->success('审核完成');
        }

        $this->assign('row',$info);
        return $this->view->fetch();
    }

}
